package org.jeecg.modules.studytourImage.controller;

import java.io.UnsupportedEncodingException;
import java.io.IOException;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.vo.LoginUser;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.studytourImage.entity.StudytourImageContent;
import org.jeecg.modules.studytourImage.entity.StudytourImage;
import org.jeecg.modules.studytourImage.vo.StudytourImagePage;
import org.jeecg.modules.studytourImage.service.IStudytourImageService;
import org.jeecg.modules.studytourImage.service.IStudytourImageContentService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: 图片直播表
 * @Author: jeecg-boot
 * @Date:   2025-09-12
 * @Version: V1.0
 */
@Api(tags="图片直播表")
@RestController
@RequestMapping("/studytourImage/studytourImage")
@Slf4j
public class StudytourImageController {
	@Autowired
	private IStudytourImageService studytourImageService;
	@Autowired
	private IStudytourImageContentService studytourImageContentService;
	
	/**
	 * 分页列表查询
	 *
	 * @param studytourImage
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "图片直播表-分页列表查询")
	@ApiOperation(value="图片直播表-分页列表查询", notes="图片直播表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<StudytourImage>> queryPageList(StudytourImage studytourImage,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<StudytourImage> queryWrapper = QueryGenerator.initQueryWrapper(studytourImage, req.getParameterMap());
		Page<StudytourImage> page = new Page<StudytourImage>(pageNo, pageSize);
		IPage<StudytourImage> pageList = studytourImageService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param studytourImagePage
	 * @return
	 */
	@AutoLog(value = "图片直播表-添加")
	@ApiOperation(value="图片直播表-添加", notes="图片直播表-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StudytourImagePage studytourImagePage) {
		StudytourImage studytourImage = new StudytourImage();
		BeanUtils.copyProperties(studytourImagePage, studytourImage);
		studytourImageService.saveMain(studytourImage, studytourImagePage.getStudytourImageContentList());
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param studytourImagePage
	 * @return
	 */
	@AutoLog(value = "图片直播表-编辑")
	@ApiOperation(value="图片直播表-编辑", notes="图片直播表-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody StudytourImagePage studytourImagePage) {
		StudytourImage studytourImage = new StudytourImage();
		BeanUtils.copyProperties(studytourImagePage, studytourImage);
		StudytourImage studytourImageEntity = studytourImageService.getById(studytourImage.getId());
		if(studytourImageEntity==null) {
			return Result.error("未找到对应数据");
		}
		studytourImageService.updateMain(studytourImage, studytourImagePage.getStudytourImageContentList());
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "图片直播表-通过id删除")
	@ApiOperation(value="图片直播表-通过id删除", notes="图片直播表-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		studytourImageService.delMain(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "图片直播表-批量删除")
	@ApiOperation(value="图片直播表-批量删除", notes="图片直播表-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.studytourImageService.delBatchMain(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功！");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "图片直播表-通过id查询")
	@ApiOperation(value="图片直播表-通过id查询", notes="图片直播表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<StudytourImage> queryById(@RequestParam(name="id",required=true) String id) {
		StudytourImage studytourImage = studytourImageService.getById(id);
		if(studytourImage==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(studytourImage);

	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "用户图片直播表通过主表ID查询")
	@ApiOperation(value="用户图片直播表主表ID查询", notes="用户图片直播表-通主表ID查询")
	@GetMapping(value = "/queryStudytourImageContentByMainId")
	public Result<List<StudytourImageContent>> queryStudytourImageContentListByMainId(@RequestParam(name="id",required=true) String id) {
		List<StudytourImageContent> studytourImageContentList = studytourImageContentService.selectByMainId(id);
		return Result.OK(studytourImageContentList);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param studytourImage
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, StudytourImage studytourImage) {
      // Step.1 组装查询条件查询数据
      QueryWrapper<StudytourImage> queryWrapper = QueryGenerator.initQueryWrapper(studytourImage, request.getParameterMap());
      LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

      //Step.2 获取导出数据
      List<StudytourImage> queryList = studytourImageService.list(queryWrapper);
      // 过滤选中数据
      String selections = request.getParameter("selections");
      List<StudytourImage> studytourImageList = new ArrayList<StudytourImage>();
      if(oConvertUtils.isEmpty(selections)) {
          studytourImageList = queryList;
      }else {
          List<String> selectionList = Arrays.asList(selections.split(","));
          studytourImageList = queryList.stream().filter(item -> selectionList.contains(item.getId())).collect(Collectors.toList());
      }

      // Step.3 组装pageList
      List<StudytourImagePage> pageList = new ArrayList<StudytourImagePage>();
      for (StudytourImage main : studytourImageList) {
          StudytourImagePage vo = new StudytourImagePage();
          BeanUtils.copyProperties(main, vo);
          List<StudytourImageContent> studytourImageContentList = studytourImageContentService.selectByMainId(main.getId());
          vo.setStudytourImageContentList(studytourImageContentList);
          pageList.add(vo);
      }

      // Step.4 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      mv.addObject(NormalExcelConstants.FILE_NAME, "图片直播表列表");
      mv.addObject(NormalExcelConstants.CLASS, StudytourImagePage.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("图片直播表数据", "导出人:"+sysUser.getRealname(), "图片直播表"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
    }

    /**
    * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();// 获取上传文件对象
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<StudytourImagePage> list = ExcelImportUtil.importExcel(file.getInputStream(), StudytourImagePage.class, params);
              for (StudytourImagePage page : list) {
                  StudytourImage po = new StudytourImage();
                  BeanUtils.copyProperties(page, po);
                  studytourImageService.saveMain(po, page.getStudytourImageContentList());
              }
              return Result.OK("文件导入成功！数据行数:" + list.size());
          } catch (Exception e) {
              log.error(e.getMessage(),e);
              return Result.error("文件导入失败:"+e.getMessage());
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.OK("文件导入失败！");
    }

}
